# pip requirements files

## Index

These files are generated by `tools/generate_requirements.py` from `pyproject.toml`.

- [default.txt](default.txt)
  Default project dependencies.
- [build.txt](build.txt)
  Requirements for building from the source repository.
- [data.txt](data.txt)
  Data requirements.
- [developer.txt](developer.txt)
  Developer requirements.
- [docs.txt](docs.txt)
  Documentation requirements.
- [optional.txt](optional.txt)
  Optional requirements. All of these are installable without a compiler through pypi.
- [test.txt](test.txt)
  Requirements for running test suite.

## Examples

### Installing requirements

```bash
$ pip install -U -r requirements/default.txt
```

### Running the tests

```bash
$ pip install -U -r requirements/default.txt
$ pip install -U -r requirements/test.txt
```
